﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using Telerik.Windows.Controls;

namespace PanelBar_ExpandLastItem
{
    public partial class MainPage : UserControl
    {
        private List<DataItem> dataSource;

        public MainPage()
        {
            InitializeComponent();
            this.dataSource = this.GenerateData();
            this.panelBar.ItemsSource = this.dataSource;
        }

        private List<DataItem> GenerateData()
        {
            List<DataItem> result = new List<DataItem>();

            foreach (var i in Enumerable.Range(1, 10))
            {
                DataItem item = new DataItem()
                {
                    Title = String.Format("Item {0}", i)
                };

                foreach (var j in Enumerable.Range(1, 3))
                {
                    DataItem subItem = new DataItem()
                    {
                        Title = String.Format("Item {0}.{1}", i, j)
                    };

                    item.Items.Add(subItem);
                }

                result.Add(item);
            }

            return result;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            foreach (var i in this.dataSource)
            {
                RadPanelBarItem container = this.panelBar.ItemContainerGenerator.ContainerFromItem(i) as RadPanelBarItem;
                if (container != null &&
                    container.IsExpanded)
                {
                    container.IsExpanded = false;
                }
            }

            RadPanelBarItem lastContainer = this.panelBar.ItemContainerGenerator.ContainerFromIndex(this.dataSource.Count - 1) as RadPanelBarItem;
            if (lastContainer != null &&
                !lastContainer.IsExpanded)
            {
                lastContainer.IsExpanded = true;
            }
        }
    }

    public class DataItem
    {
        public DataItem()
        {
            this.Items = new List<DataItem>();
        }

        public string Title { get; set; }
        public List<DataItem> Items { get; set; }
    }
}
